<template>
  <div class="set-filter">

    <div
      v-if="isDisabled"
      class="ui button blue small icon trigger-filter disabled"
      :class="{loading: loading}">
      <i
        v-if="!loading"
        class="icon advanced filter"/>
      <i
        v-else
        class="icon advanced"/>
      <span
        class="count-values"
        v-if="resultValues.length>0">{{ resultValues.length }}</span>
    </div>
    <template v-else>
      <v-popover
        v-if="filter.value==='PERIOD'"
        popover-base-class="tooltip kit white"
        popover-arrow-class="tooltip-arrow"
        popover-inner-class=""
        popover-class=""
        :handle-resize=true
        trigger="hover"
        placement="bottom"
        offset=4
        delay=0>

        <div class="ui button blue small icon trigger-filter disabled">
          <i class="icon advanced filter"/>
        </div>

        <template slot="popover">
          <p style="width: 15rem">
            Для фильтрации по дате выберите нужный диапазон в календаре сверху.
          </p>
        </template>
      </v-popover>

      <v-popover
        v-else
        popover-base-class="tooltip kit white"
        popover-arrow-class="tooltip-arrow"
        popover-inner-class=""
        popover-class=""
        :auto-hide="false"
        :open.sync="state.open"
        :handle-resize=true
        trigger="manual"
        placement="bottom"
        offset=4
        delay=0>

        <button
          type="button"
          class="ui button blue small icon trigger-filter"
          :class="{loading: loading}"
          @click="togglePopover">
          <i
            v-if="!loading"
            class="icon advanced filter"/>
          <i
            v-else
            class="icon advanced"/>
          <span
            class="count-values"
            v-if="resultValues.length>0">{{ resultValues.length }}</span>
        </button>

        <template slot="popover">
          <div class="filters">
            <div
              class="close"
              @click="close"/>
            <div class="list all">
              <div class="title">Параметры фильтрации:</div>
              <div class="item">
                <div class="ui input">
                  <input
                    type="text"
                    placeholder="Введите название"
                    v-model="search">
                </div>
              </div>
              <div class="scroll">
                <div
                  class="item"
                  v-for="(param,item) in searchedList"
                  :key="item">
                  <div class="ui checkbox">
                    <input
                      type="checkbox"
                      :name="'param-' + item"
                      :id="'param-' + item"
                      @change="toggleItem(param)"
                      :checked="isSelected(param)">
                    <label :for="'param-' + item">{{ param.text }}</label>
                  </div>
                </div>
              </div>

            </div>
            <div class="list selected">
              <div class="title">Выбрано:</div>
              <div class="scroll">
                <div
                  class="item"
                  v-for="(param,item) in values"
                  :key="'s'+item">
                  <div class="param">{{ param.text }}</div>
                  <div
                    class="delete"
                    @click="toggleItem(param)"/>
                </div>
              </div>
            </div>
            <button
              v-if="isChanged"
              class="ui button yellow small"
              @click="save">Применить</button>
          </div>
        </template>

      </v-popover>
    </template>


  </div>
</template>

<script>
import {
  findIndex,
  filter,
  clone,
  map,
  isEqual,
} from 'lodash-es';

export default {
  name: 'SetFilter',
  props: {
    filter: {
      type: Object,
      default: null,
    },
    selected: {
      type: Array,
      default: null,
    },
  },
  data() {
    return {
      state: {
        open: false,
      },
      search: '',
      values: [],
      valuesSaved: [],
    };
  },
  computed: {
    loading() {
      return this.filter !== null && this.filter.loading;
    },
    isDisabled() {
      return this.filter === null || this.filter.list.length === 0;
    },
    searchFor() {
      return this.search.toUpperCase();
    },
    searchedList() {
      if (this.search !== '') {
        return filter(this.filter.list, it => it.text.toUpperCase().indexOf(this.searchFor) !== -1);
      }
      return this.filter.list;
    },
    resultValues() {
      return map(this.values, el => el.id).sort();
    },
    resultSaved() {
      return map(this.valuesSaved, el => el.id).sort();
    },
    isChanged() {
      if (this.values.length !== this.valuesSaved.length) {
        return true;
      } if (this.values.length === 0) {
        return false;
      }
      return !isEqual(this.resultSaved, this.resultValues);
    },
  },
  watch: {
    'state.open'() {
      this.search = '';
    },
    filter(val) {
      this.init(val);
    },
    selected(val) {
      this.valuesSaved = [];
      this.values = [];
      if (val !== null && val.length > 0 && this.filter !== null) {
        this.valuesSaved = filter(this.filter.list, el => val.indexOf(el.id) !== -1);
        this.values = clone(this.valuesSaved);
      }
    },
  },
  mounted() {
    this.init(this.filter);
  },
  methods: {
    init(val) {
      this.valuesSaved = [];
      this.values = [];
      if (val !== null && val.selected.length > 0) {
        this.valuesSaved = filter(val.list, el => val.selected.indexOf(el.id) !== -1);
        this.values = clone(this.valuesSaved);
      }
    },
    save() {
      this.valuesSaved = clone(this.values);
      this.state.open = false;
      this.filter.selected = map(this.valuesSaved, el => el.id);
      this.$emit('filter', this.filter.value);
    },
    close() {
      this.values = clone(this.valuesSaved);
      this.state.open = false;
    },
    isSelected(item) {
      return findIndex(this.values, { id: item.id }) !== -1;
    },
    togglePopover() {
      if (!this.isDisabled) {
        this.state.open = !this.state.open;
      }
    },
    toggleItem(item) {
      const ind = findIndex(this.values, { id: item.id });
      if (ind !== -1) {
        this.values.splice(ind, 1);
      } else {
        this.values.push(item);
      }
    },
  },

};
</script>

<style scoped lang="scss">
  @import "../../../../assets/css/pages/cabinet/_tooltip-old.css";

  .set-filter {
    position: relative;
    padding-right: 0.75rem;
    .ui.button.trigger-filter {
      display: flex;
      justify-content: center;
      align-items: center;
      padding: 0;
      min-width: 2rem;
      min-height: 2rem;
      @media screen and (max-width: 980px) {
        width: 3rem;
        height: 3rem;
      }
    }
    .count-values {
      position: absolute;
      top: -0.5rem;
      left: 1.5rem;
      display: block;
      width: auto;
      min-width: 1rem;
      height: 1rem;
      padding: 0 0.25rem;
      font-weight: 700;
      line-height: 1rem;
      font-size: 0.625rem;
      color: #4272a4;
      border-radius: 50%;
      background-color: #fff;
      border: 1px solid #4272a4;
      @media screen and (max-width: 980px) {
        left: 2rem;
        min-width: 1.5rem;
        height: 1.5rem;
        padding: 0 0.375rem;
        font-size: 1rem;
        line-height: 1.5rem;
      }
    }

  }
</style>
